package eu.clarin.cmdi.mdservice.action;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.Map;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import eu.clarin.cmdi.mdservice.internal.CQLParseException;
import eu.clarin.cmdi.mdservice.internal.Cache;
import eu.clarin.cmdi.mdservice.internal.NoStylesheetException;
import eu.clarin.cmdi.mdservice.internal.Utils;
import eu.clarin.cmdi.mdservice.model.Diagnostic;
import eu.clarin.cmdi.mdservice.model.Query;
import eu.clarin.cmdi.mdservice.model.WorkspaceProfile;
import eu.clarin.cmdi.mdservice.proxy.FCSProxy;
import eu.clarin.cmdi.mdservice.proxy.MDRepoProxy;
import eu.clarin.cmdi.mdservice.proxy.Pz2Proxy;
import eu.clarin.cmdi.mdservice.proxy.SRUProxy;




public class FCSAction extends SRUAction 
{

	private static final long serialVersionUID = 1L;
	
	/** 
	 * Properties to be filled by Struts with according request-parameters
	 */	
	/*
	private String q;
	private String version;
	private String operation;
	private String query;
	private String scanClause;
	private int startRecord;
	private int maximumRecords;
	private String recordPacking;
	private String recordSchema;
	private String recordXPath;
	private int resultSetTTL;
	private String sortKeys;
	private String stylesheet;	
	private String x_cmd_repository;
	private String x_cmd_collections;
	private Set paramSet;
*/
	private String x_content;
	private Map<String,String[]> fcsparams;
	
	private static int OP_SEARCHRETRIEVE = 1;
	private static int OP_EXPLAIN = 2;
	private static int OP_SCAN = 3;
	
	
	//TODO cache after analysis ?
	@Override
	public String getCache() {
		return Cache.SKIP;
	}
	
	/*
	@Override
	public String getRepository() {
		//return getParam("x-content");
		if (WorkspaceProfile.getFCSMapping(params.get("x-context")[0]) == null){
					return getParam("x-context");
				} else {
					return WorkspaceProfile.getFCSMapping(params.get("x-context")[0]);
				}
	}
*/
	 
	/**
	 * primitive identification of the target-proxy
	 * base for finding the right base_url in the props
	 * subclass has to override with its specific proxykey
	 * @return
	 */
	public String getProxyKey() {
		return "";
	}

	@Override
	public String getFullFormat() {		
		return getActionkey() + getOperation() + "2" + getFormat();
	}
	
	public void addFCSParam(String key, String value){
		String[] sarr = new String[1];
		sarr[0] = value;
		fcsparams.put(key, sarr);	
	}
	public Map<String, String[]> getFCSParams(){
		if (fcsparams == null){

			fcsparams = new HashMap<String, String[]>();
			
			if ( params.get("operation") != null){
				addFCSParam("operation",params.get("operation")[0]);
			}
			if ( params.get("scanClause") != null){
				addFCSParam("scanClause",params.get("scanClause")[0]);
			}
			if ( params.get("query") != null){
				addFCSParam("query",params.get("query")[0]);
			}
			if ( params.get("x-context") != null){
				if (WorkspaceProfile.getFCSMapping(params.get("x-context")[0]) != null){
					addFCSParam("x-context",params.get("x-context")[0]);
				}
				
			}
		
		}
		
		return fcsparams;
		
	}
	
	@Override
	public String getFormat() {
		if (getParams().get("x-format") == null){
				return "xml";
		}
		return getParam("x-format");
		
	}
	
	@Override
	protected void setDefaultParams(){
		// set defaults
		
			if (params.get("x-context") != null){
				
				// search in fcs-mapping
				if (WorkspaceProfile.getFCSMapping(params.get("x-context")[0]) == null){
					addParam("repository",params.get("x-context")[0]);
				} else {
					addParam("repository",WorkspaceProfile.getFCSMapping(params.get("x-context")[0]));
				}
			}	

		addParam("fullformat",getFullFormat());
		
		if (params.get("scripts_url") == null){
			addParam("scripts_url",Utils.getConfig("webscripts.uri"));
		}
		
		if (params.get("base_url") == null){
			addParam("base_url",Utils.getConfig("base.uri"));
		}
		if (params.get("cache") == null){
			addParam("cache",Cache.SKIP);
		} 
	}
	
	@Override
	public boolean checkTargetProxy(){
		//if ( getTargetProxy() == null) return false;
		return true;
	}
	
	@Override
	public void checkParams(){
		if (getTargetProxy() != null){
			getTargetProxy().checkParams();	
		}
	}
	@Override
	public InputStream getSourceStream() throws IOException, NoStylesheetException, CQLParseException {		
		// TODO condition case scan 
		if (getTargetProxy() == null){
			WorkspaceRepositoryAction wra = new WorkspaceRepositoryAction();
			wra.setParam("format","sruscan");
			wra.setType("SERVER");
			try {
				if (wra.execute() == SUCCESS){
					return wra.getResultStream();
				}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return null;
		}
		return getTargetProxy().getSourceStream(); 
		
	}
	/*
	@Override
	public void prepare()  {
		
		loadParams();
		// case scan
		if ((getRepository().equals("")) && (getParam("operation").equals("scan"))){
			//TODO
			WorkspaceRepositoryAction wra = new WorkspaceRepositoryAction();
			wra.setParam("format","sruscan");
			wra.setType("SERVER");
			try {
				if (wra.execute() == SUCCESS){
					setResultStream(wra.getResultStream());
				}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			//WorkspaceProfile.getRepositories()
			return;
		}
		super.prepare();
	}
		*/
	@Override
	public void setTargetProxy(){
		
		//Query query = new Query();
		
		if ((getRepository().equals("")) && (getParam("operation").equals("scan"))){
			return;
		}
		switch (WorkspaceProfile.RepositoryType.toRepositoryType(WorkspaceProfile.getRepositoryType(getRepository())))
		{		
		    case PAZPAR: 
		    	setTargetProxy(new Pz2Proxy(new Query(getActionkey(), this.getParams())));
		    	return;
		    case SRU:
		    	setTargetProxy(new SRUProxy(new Query(Query.SRUEXTERN,getParams())));
		    	return;
		    case MD:
		    	setTargetProxy(new MDRepoProxy(new Query(Query.RECORDSET,getParams())));
		    	return;	
		    case FCS:
		    	setTargetProxy(new FCSProxy(new Query(Query.FCSRECORDSET,getFCSParams())));
		    	return;
		    case FCSRESOURCE:
		    	setTargetProxy(new FCSProxy(new Query(Query.FCSRECORDSET,getFCSParams())));
		    	return;
		    default:
		    	//TODO error  = bad workspaceProfile configuration
		    	getDiagnostics().Add(Diagnostic.SYSTEM_ERROR, "Error in workspaceprofile configuration", "repository=" + getRepository() );
		}
}
}